{$R-,Q-,S-,Q-}
{  }
Uses crt;                                  { for keypressed only }

procedure SetPalette;
  function f(x:real):integer;
  begin
    if (0<=x) and (x<=1) then f:=round(63*x*(2-x));
    if x<0 then f:=0;
    if x>1.0 then f:=63;
  end;
  var   N, C : Integer;
begin
  Port[$3C8] := 0;
  for N := 0 to 255 do begin
    Port[$3C9] := f(n/255); {r}
    Port[$3C9] := f(n/255-0.2); {g}
    Port[$3C9] := f(n/255-0.5){+f(0.1-n/255)*n div 7}; {b}
  end;
end; {of SetPalette}


var BiosTicks: longint absolute $0040:$006C;

const
  Flakes = 500;            { try less flakes for faster snowfall }
  const fading:integer=4;

{---------------- Stuff not specific to snowfall ----------------}
Procedure vidMode(mode : byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

var Scr: array[0..199,0..319] of byte absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;
var Scr2: TScr2 absolute $A000:$0000;
var Scr3, Scr4: ^TScr2;

procedure line(x1,y1,x2,y2:integer);
var i,j:integer;
begin
  i := abs(x2-x1);
  j := abs(y2-y1);
  if i<j then i:=j;

  for j := 0 to i do begin
    scr4^[320*(y1+round((y2-y1)/i*j))+x1+round((x2-x1)/i*j)] := 255;
  end;
end;

procedure wash(var source, dest); assembler;
label m1, m2;
asm
  push ds
  push es

  mov  dx, fading
  xor  dh,dh
  mov  ds, word ptr [dest+2]
  mov  es, word ptr [source+2]
  xor  si,si
  xor  di,di

  xor  bx,bx

m1:
  xor  ah,ah
(**)
  mov  al,[es:si]
  shl  ax,2
  mov  bl,[es:si+1]
  add  ax,bx
  mov  bl,[es:si-1]
  add  ax,bx
  mov  bl,[es:si+320]
  add  ax,bx
  mov  bl,[es:si-320]
  add  ax,bx
  shr  ax,3
  mov  [ds:di],al
  sub  al, dl
  jb   m2
  mov  [ds:di],al
m2:
  dec  di
  dec  si
  jnz  m1

  pop  es
  pop  ds
end;

procedure movs(var source, dest); assembler;
asm
  push ds
  push es
  mov  es, word ptr [dest+2]
  mov  ds, word ptr [source+2]
  xor  si,si
  xor  di,di
  mov  cx, $4000
  cld
  db $66     { \\\           }
  rep  movsw { /// rep movsd }
  pop  es
  pop  ds
end;

{---------------------------MAIN PROGRAM-------------------------}

var
  CurFlake : integer;                        { snowflake counter }
  i : longint;                       { to add velocity to flakes }
  j: word;
  x,y, newPos: array[0..Flakes] of integer;         { lookup tables }
var b1,i1: longint;
    tmpPtr:pointer;
  label m1,m2,mexit;
var t1,t2,t3:longint; { ६ ᪮ ணࠬ}
BEGIN
  t1:=0; t2:=0; t3:=0;
  randomize;
  for curFlake:=0 to Flakes do        { set up snow lookup table }
  begin
    X[CurFLAKE]:=Round(220*Cos(CurFLAKE*2*PI/Flakes))+Random(25)-12 {-159+Random(319){};
    Y[CurFLAKE]:=Round(220*Sin(CurFLAKE*2*PI/Flakes))+Random(25)-12 {-99+Random(199){};
  end;

  VIDMode($13);                       { 320x200x256 graphics mode }

  SetPalette;

{  for i := 0 to 63999 do scr2[i] := i div (64000 div 256);
  readkey; {show palette}

  i := -1000; { change to 100 or higher to get rid of start explosion }

  GetMem(Scr3,65535);
  GetMem(Scr4,65535);
  FillChar(Scr4^,65535,#0);
{  FillChar(Scr3^,65535,#200);}

  b1 := BiosTicks;
  i1 := i;
  repeat
    inc(i);

    dec(t1,biosticks); { 1 稪 ६}
    for curFlake:=0 to Flakes do
      begin
{        setPixel(newPos[curFlake], 0);     { erase old snowflake }
{      x[curFlake]:=round(x[curflake]*0.99+y[curflake]*0.1);
      y[curFlake]:=round(y[curflake]*0.99-x[curflake]*0.1);}
        NewPos[CurFLAKE] :=      { set up and draw new snowflake }
          Round(160+X[CurFLAKE]*(I*0.005)) +                  { new X }
          Round(100+Y[CurFLAKE]*(I*0.005)) * 320;             { new Y }
        Scr4^[NewPos[CurFLAKE]] := 255;
{        if curflake>0 then line
         (round(160+x[curFlake]*(i*0.005)) mod 320, round(100+y[curFlake]*(i*0.005)) mod 200,
          round(160+x[curFlake-1]*(i*0.005)) mod 320, round(100+y[curFlake-1]*(i*0.005)) mod 200 );}
      end;
    inc(t1,biosticks); {⮯ 1 稪 ६}

    dec(t2,biosticks); { 2 稪 ६}
    wash(scr4^,scr3^);
    inc(t2,biosticks); {⮯ 2 稪 ६}

    dec(t3,biosticks); { 3 稪 ६}
{    Scr2 := Scr3^;}
    movs(Scr3^, Scr2);
{    Scr4^ := Scr3^; {ଠ}
    TmpPtr:=Scr3; Scr3:=Scr4; Scr4 := TmpPtr;
{    movs(Scr3^, Scr4^);}
{    Move(Scr3^[320],Scr4^,65535); { ᭮ }
{    Move(Scr3^[8192],Scr4^,65535); {'' }
    inc(t3,biosticks); {⮯ 3 稪 ६}

    if keypressed then case readkey of
      ' ': for j:=0 to Flakes do begin
             x[j] := 0;
             y[j] := 0;
           end;
      '-': inc(fading);
      '+': dec(fading);
      '*': fading :=0;
      #27: goto mexit;
    end;
  until false;

  mexit:
  b1 := biosticks-b1;
  vidMode($03);                       { return to 80x25 textmode }
  writeln(' ',i-i1,' frames, ',(BiosTicks-b1)/18.2:1:2,' seconds, ',
             (i-i1)/b1*18.2:1:2,' frames per second.' );
  writeln('  T1 = ', t1/18.2:1:3,', ',t1/b1*100:1:1,'% ',
          '  T2 = ', T2/18.2:1:3,', ',t2/b1*100:1:1,'% ',
          '  T3 = ', T3/18.2:1:3,', ',t3/b1*100:1:1,'% ',
          '  T1+T2+T3 = ',(T1+T2+T3)/18.2:1:3,  '.');
end.

