Program SnowFall;
Uses crt;                                  { for keypressed only }

procedure SetPalette;

function f(x:real):integer;
begin
  if (0<=x) and (x<=1) then f:=round(63*x*(2-x));
  if x<0 then f:=0;
  if x>1.0 then f:=63;
end;

var   N, C : Integer;

begin
  Port[$3C8] := 0;
  for N := 0 to 255 do begin
    Port[$3C9] := f(n/255);
    Port[$3C9] := f(n/255-0.2);
    Port[$3C9] := f(n/255-0.5)+f(0.1-n/255)*n div 7;
  end;
end; {of SetPalette}


const
  Flakes = 500;            { try less flakes for faster snowfall }

{---------------- Stuff not specific to snowfall ----------------}
Procedure vidMode(mode : byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

Procedure setPixel(pixPos : word; color : byte);
begin
    mem[$A000:pixPos] := color;
end;

var Scr: array[0..199,0..319] of byte absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;
var Scr2: TScr2 absolute $A000:$0000;
var Scr3: ^TScr2;

{---------------------------MAIN PROGRAM-------------------------}

var
  CurFlake : integer;                        { snowflake counter }
  i : longint;                       { to add velocity to flakes }
  j: word;
  x,y, newPos: array[0..Flakes] of integer;         { lookup tables }
  label m1,m2,mexit;

BEGIN
  randomize;
  for curFlake:=0 to Flakes do        { set up snow lookup table }
  begin
    x[curFlake]:=-159+random(319);
    y[curFlake]:=-99+random(199);
  end;

  vidMode($13);                       { 320x200x256 graphics mode }

  SetPalette;

  i := 500; { change to 100 or higher to get rid of start explosion }

  New(Scr3);

  repeat
    inc(i);

    for j := 63998 downto 321 do begin
      scr3^[j] :=
        ( Scr2[j] shl 2 + Scr2[j+1]+Scr2[j-1]+Scr2[j-320]+Scr2[j+320] ) shr 3;{}
      if scr3^[j] > 0 then dec(scr3^[j]);{}
    end;
    Scr2 := Scr3^;

    for curFlake:=0 to Flakes do
      begin
{        setPixel(newPos[curFlake], 0);     { erase old snowflake }
        newPos[curFlake] :=      { set up and draw new snowflake }
          round(x[curFlake]*(i*0.01)) +                  { new X }
          round(y[curFlake]*(i*0.01)) * 320;             { new Y }
        setPixel(newPos[curFlake], (curFlake mod 13) + (256-13));
      end;

    while (port[$3da] and $08) = $08 do;  { wait for vRetrace to }
    while (port[$3da] and $08) = $00 do;  { start and end        }
    if keypressed then case readkey of
      ' ': for j:=0 to Flakes do begin
             x[j] := 0;
             y[j] := 0;
           end;
      #27: goto mexit;
    end;
  until false;

  mexit:
  vidMode($03);                       { return to 80x25 textmode }
  writeln('i = ',i);
end.

